/* tslint:disable */
/* eslint-disable */
/**
 * Coscine.Api.STS
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
/**
 * ShibbolethApi - axios parameter creator
 * @export
 */
export const ShibbolethApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Callback method to catch the login
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {string | null} [remoteError] Erros on remote login
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shibbolethCallback: async (returnUrl?: string | null, remoteError?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/Shibboleth/callback`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }

            if (remoteError !== undefined) {
                localVarQueryParameter['remoteError'] = remoteError;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary This method is the central route for logging into an identity provider. On default, the user is redirected to the WAFY of the DFN-AAI. Setting the \"entityId\" parameter allows the application to redirect to a specific identity provider defined by DFN-AAI.
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {string | null} [entityId] Specific Identitiy Provider to be redirect to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shibbolethLogin: async (returnUrl?: string | null, entityId?: string | null, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/Shibboleth/login`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication JWT token required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (returnUrl !== undefined) {
                localVarQueryParameter['returnUrl'] = returnUrl;
            }

            if (entityId !== undefined) {
                localVarQueryParameter['entityId'] = entityId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ShibbolethApi - functional programming interface
 * @export
 */
export const ShibbolethApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ShibbolethApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Callback method to catch the login
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {string | null} [remoteError] Erros on remote login
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async shibbolethCallback(returnUrl?: string | null, remoteError?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.shibbolethCallback(returnUrl, remoteError, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['ShibbolethApi.shibbolethCallback']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @summary This method is the central route for logging into an identity provider. On default, the user is redirected to the WAFY of the DFN-AAI. Setting the \"entityId\" parameter allows the application to redirect to a specific identity provider defined by DFN-AAI.
         * @param {string | null} [returnUrl] URL to be redirected to
         * @param {string | null} [entityId] Specific Identitiy Provider to be redirect to
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async shibbolethLogin(returnUrl?: string | null, entityId?: string | null, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<File>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.shibbolethLogin(returnUrl, entityId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['ShibbolethApi.shibbolethLogin']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * ShibbolethApi - factory interface
 * @export
 */
export const ShibbolethApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ShibbolethApiFp(configuration)
    return {
        /**
         * 
         * @summary Callback method to catch the login
         * @param {ShibbolethApiShibbolethCallbackRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shibbolethCallback(requestParameters: ShibbolethApiShibbolethCallbackRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.shibbolethCallback(requestParameters.returnUrl, requestParameters.remoteError, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary This method is the central route for logging into an identity provider. On default, the user is redirected to the WAFY of the DFN-AAI. Setting the \"entityId\" parameter allows the application to redirect to a specific identity provider defined by DFN-AAI.
         * @param {ShibbolethApiShibbolethLoginRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        shibbolethLogin(requestParameters: ShibbolethApiShibbolethLoginRequest = {}, options?: AxiosRequestConfig): AxiosPromise<File> {
            return localVarFp.shibbolethLogin(requestParameters.returnUrl, requestParameters.entityId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for shibbolethCallback operation in ShibbolethApi.
 * @export
 * @interface ShibbolethApiShibbolethCallbackRequest
 */
export interface ShibbolethApiShibbolethCallbackRequest {
    /**
     * URL to be redirected to
     * @type {string}
     * @memberof ShibbolethApiShibbolethCallback
     */
    readonly returnUrl?: string | null

    /**
     * Erros on remote login
     * @type {string}
     * @memberof ShibbolethApiShibbolethCallback
     */
    readonly remoteError?: string | null
}

/**
 * Request parameters for shibbolethLogin operation in ShibbolethApi.
 * @export
 * @interface ShibbolethApiShibbolethLoginRequest
 */
export interface ShibbolethApiShibbolethLoginRequest {
    /**
     * URL to be redirected to
     * @type {string}
     * @memberof ShibbolethApiShibbolethLogin
     */
    readonly returnUrl?: string | null

    /**
     * Specific Identitiy Provider to be redirect to
     * @type {string}
     * @memberof ShibbolethApiShibbolethLogin
     */
    readonly entityId?: string | null
}

/**
 * ShibbolethApi - object-oriented interface
 * @export
 * @class ShibbolethApi
 * @extends {BaseAPI}
 */
export class ShibbolethApi extends BaseAPI {
    /**
     * 
     * @summary Callback method to catch the login
     * @param {ShibbolethApiShibbolethCallbackRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ShibbolethApi
     */
    public shibbolethCallback(requestParameters: ShibbolethApiShibbolethCallbackRequest = {}, options?: AxiosRequestConfig) {
        return ShibbolethApiFp(this.configuration).shibbolethCallback(requestParameters.returnUrl, requestParameters.remoteError, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary This method is the central route for logging into an identity provider. On default, the user is redirected to the WAFY of the DFN-AAI. Setting the \"entityId\" parameter allows the application to redirect to a specific identity provider defined by DFN-AAI.
     * @param {ShibbolethApiShibbolethLoginRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ShibbolethApi
     */
    public shibbolethLogin(requestParameters: ShibbolethApiShibbolethLoginRequest = {}, options?: AxiosRequestConfig) {
        return ShibbolethApiFp(this.configuration).shibbolethLogin(requestParameters.returnUrl, requestParameters.entityId, options).then((request) => request(this.axios, this.basePath));
    }
}

